LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

entity DAC is
  port (
    clk : in std_logic;
    
	 SCLK_DAC : out std_logic;
	 SYNC : out std_logic;
	 DIN : out std_logic;

	 DAC_out : in unsigned(9 downto 0) := to_unsigned(0, 10)

  );
end DAC;

architecture Behavioral of DAC is
  signal clk_z4 : unsigned(1 downto 0) := "00";					--set ADC clock
  signal clk_adc : std_logic := '0';						--clock to ADC
  signal CS_cnt : unsigned(3 downto 0) := "0000";				--set CS interval
  signal CS_sig : std_logic := '0';						--CS to ADC

  signal clk_DAC : std_logic := '1';
  signal signal_to_DAC : unsigned(15 downto 0) := to_unsigned(0, 16);
  signal signal_to_DAC_cnt : unsigned(3 downto 0) := "0000";
  signal SYNC_sig : std_logic := '1';
  signal SCLK_DAC_cnt : unsigned(4 downto 0) := to_unsigned(0, 5);
  
  
  
  

  
begin



process(clk)
begin

  if (rising_edge(clk)) then
    clk_z4 <= not clk_z4;

    if clk_z4 >= "01" then 		--set ADC clock (ADC MAX11105AUT+T)
      clk_adc <= not clk_adc;
      clk_z4 <= "00";
    else
      clk_z4 <= clk_z4 + 1;
    end if;
  
    if clk_z4 = "01" and clk_adc = '0' then	--rising_edge(clk_adc)
      CS_cnt <= CS_cnt +1;			
    end if;

    if CS_cnt = "1111" then			--set ADC's "CS" input interval
      CS_sig <= '0';
    end if;
    if CS_cnt = "1101" then
      CS_sig <= '1';
    end if;


	 
	 
---------  DAC  ---------
    clk_DAC <= not clk_DAC;				--clk divided by 2


    if CS_cnt = "1111" then
      if CS_sig = '1' then				--falling_edge(CS_sig)
        signal_to_DAC(12 downto 3) <= DAC_out;
        SYNC_sig <= '0';
        SCLK_DAC_cnt <= "00000";
        signal_to_DAC_cnt <= "1101";
      end if;
    end if;

    if SYNC_sig = '0' and clk_z4 = "01" and clk_adc = '1' then
      SCLK_DAC_cnt <= SCLK_DAC_cnt +1;
    end if;

    if CS_cnt = "1110" and clk_adc = '0' then
      SYNC_sig <= '1';
    end if;
		
		
    if clk_z4 = "01" and clk_adc = '0' then	--falling_edge(clk_adc)
      if SYNC_sig = '0' then
        signal_to_DAC_cnt <= signal_to_DAC_cnt - 1;
        DIN <= signal_to_DAC(to_integer(signal_to_DAC_cnt));
      end if;
    end if;
	 
  end if;
  
end process;

  SYNC <= SYNC_sig;
  SCLK_DAC <= clk_adc;
  
end Behavioral;