library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity RAMctrl is
  port(
    clk   : in std_logic;
	 start : in std_logic; -- start write to array
	 write1: in std_logic; -- write new data
	 din   : in unsigned(11 downto 0); -- input data
		
	 read1 : in std_logic; --enable reading next from array
    done  : out std_logic := '0';	    --whole array read      
	 dout  : out unsigned(11 downto 0);
	 adr   : out unsigned (6 downto 0)
  );
end RAMctrl;

architecture Behavioral of RAMctrl is
  signal memory_adr : unsigned (6 downto 0) := "0000000"; --write from temp. read to array
  --signal i_tab_read : unsigned(4 downto 0) := "00000"; --read from array
  signal start_hold : std_logic := '0';
  signal start_hold_number : unsigned(6 downto 0) := "0000000";
  signal start_edge : std_logic := '0';
  signal read1_edge : std_logic := '0';
  signal DOUT_memory : unsigned(11 downto 0);

  component memory is
    port(
      clock : in std_logic;
      address : in unsigned(6 downto 0);
      data : in unsigned(11 downto 0);
      wren : in std_logic;
      q : out unsigned(11 downto 0)
    );
  end component;  
  

begin

u1 : memory port map(
  clock => clk,
  address => memory_adr,
  data => din,
  wren => write1,
  q => DOUT_memory
);


  process (clk)
  begin
    if rising_edge(clk) then
      start_edge <= start; --start impulse
      if (start = '1' and start_edge = '0') then --set/reset "start_hold"
        start_hold <= '1';
        memory_adr <= "0000000";
        done <= '0';
      end if;
      if start_hold_number = "1111111" or memory_adr = "1111111" then --read finished
        start_hold <= '0';
        memory_adr <= "0000000";
        done <= '1';
      end if;
    
	    read1_edge <= read1;
      if (read1 = '1' and read1_edge = '0') then		--read enabled		--read impulse
        memory_adr <= memory_adr + 1;
        dout <= DOUT_memory;
      end if;

	  end if;
  end process;

  start_hold_number <= memory_adr;
  adr <= memory_adr;
 
end Behavioral;