LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;
USE ieee.math_real.all;

entity rom is
 port (
   adr : in unsigned(9 downto 0);
   data : out signed(9 downto 0)
 );
end rom;

architecture Behavioral of rom is
 constant romsize: integer := 1024; -- stevilo elementov sinusne tabele

 type sintab is array(0 to romsize-1) of signed(9 downto 0);
 signal sinrom: sintab;
begin

 -- generator vsebine sinusne tabele
 g: for i in 0 to romsize-1 generate
 constant sinval: signed (9 downto 0) := to_signed(integer(511.0*sin(real(i)*2.0*math_pi/real(romsize))),10); 
 begin
  sinrom(i) <= sinval;
 end generate;  

 -- tabela kot pomnilnik ROM
 data <= sinrom(to_integer(adr));

end Behavioral;