LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;
USE ieee.math_real.all;

entity signal_gen is
  port (
    clk : in std_logic;
    delta : in std_logic_vector(9 downto 0);
	 amplitude : in std_logic_vector(4 downto 0);
    signal_select : in std_logic_vector(2 downto 0);
	 
	 DAC_out : out unsigned(9 downto 0) := to_unsigned(0, 10)
  );
end signal_gen;

architecture Behavioral of signal_gen is
  signal rom_adr : unsigned(9 downto 0) := to_unsigned(0, 10);
  signal sine_tmp : signed(9 downto 0) := to_signed(0, 10);
  signal sine_tmp1 : signed(9 downto 0) := to_signed(0, 10);
  signal sine_tmp2 : signed(10 downto 0) := to_signed(0, 11);
  signal sine : unsigned(10 downto 0) := to_unsigned(0, 11);
  
  signal signal_gen_clk : unsigned(19 downto 0) := to_unsigned(0, 20);
  signal triangle : unsigned(9 downto 0) := to_unsigned(0, 10);
  signal DAC_out_tmp : unsigned(9 downto 0) := to_unsigned(0, 10);
  signal DAC_out_tmp1 : unsigned(14 downto 0) := to_unsigned(0, 15);
  
  signal square : unsigned(9 downto 0) := to_unsigned(0, 10);

  
  
  
  component rom is
    port(
	   adr : in unsigned(9 downto 0);
		data : out signed(9 downto 0)
	 );
  end component;

begin
u3 : rom port map(
  adr  => rom_adr,
  data => sine_tmp
);

  
process(clk)
begin
 
  if (rising_edge(clk)) then
	 --sine_tmp1(9 downto 0) <= sine_tmp;
	 --sine_tmp2 <= sine_tmp1 + 511;
	 --sine <= unsigned(sine_tmp2(9 downto 0));
	 
	 sine_tmp1(9 downto 0) <= sine_tmp;
    sine_tmp2(9 downto 0) <= sine_tmp1 + 511;
    sine(9 downto 0) <= unsigned(sine_tmp2(9 downto 0));
	 
	 --delta <= "0000001000";
    signal_gen_clk <= signal_gen_clk + unsigned(delta);
    rom_adr <= signal_gen_clk(19 downto 10);

    if rom_adr > "0111111111" then
      square <= "1111111111";
    else
      square <= "0000000000";
    end if;
    
	 if rom_adr > "0111111111" then
	   triangle <= "1111111111" - signal_gen_clk(18 downto 9);
	 else
	   triangle <= signal_gen_clk(18 downto 9);
	 end if;

	 if signal_select = "100" then
	   DAC_out_tmp(9 downto 0) <= sine(9 downto 0);
	 elsif signal_select = "011" then
      DAC_out_tmp(9 downto 0) <= rom_adr(9 downto 0);
	 elsif signal_select = "010" then
	   DAC_out_tmp(9 downto 0) <= square(9 downto 0);
	 elsif signal_select = "001" then
	   DAC_out_tmp(9 downto 0) <= triangle(9 downto 0);
    elsif signal_select = "000" then
	   DAC_out_tmp(9 downto 0) <= "0000000000";
	 end if;
	 
	 
	 DAC_out <= DAC_out_tmp(9 downto 5) * unsigned(amplitude);
	 
    --ADC_out_tmp1 <= ADC_out_tmp(9 downto 0) * unsigned(amplitude);
	 --ADC_out <= ADC_out_tmp1(14 downto 5);
	end if; 
end process;
end Behavioral;